#include <Windows.h>
#include <CommCtrl.h>
#include <tchar.h>
#include "resource.h"

#pragma comment(lib, "ComCtl32.lib")
#pragma comment(lib, "User32.lib")
#pragma comment(lib, "Kernel32.lib")


BOOL WriteRS323(PCTSTR buf, UINT size)
{
    DWORD bytesWritten;
    return WriteFile((HANDLE)STD_OUTPUT_HANDLE, buf, size, &bytesWritten, NULL);
}


PCTSTR g_Commands[] =
{
    _T("Kommando-1"),
    _T("Kommando-2"),
    _T("Kommando-3"),
    _T("Kommando-4"),
    _T("Kommando-5"),
    _T("Kommando-6"),
    _T("Kommando-7"),
    _T("Kommando-8"),
    _T("Kommando-9"),
    _T("Kommando-10"),
    _T("Kommando-11"),
    _T("Kommando-12"),
    _T("Kommando-13"),
    _T("Kommando-14"),
    _T("Kommando-15"),
    _T("Kommando-16"),
    _T("Kommando-17"),
    _T("Kommando-18"),
    _T("Kommando-19"),
    _T("Kommando-20"),
    _T("Kommando-21"),
    _T("Kommando-22"),
    _T("Kommando-23"),
    _T("Kommando-24"),
    _T("Kommando-25"),
    _T("Kommando-26"),
    _T("Kommando-27"),
    _T("Kommando-28"),
    _T("Kommando-29"),
    _T("Kommando-30"),
    _T("Kommando-31"),
    _T("Kommando-32"),
};


void OnCommandButton(HWND hDlg, INT id)
{
    // Write Button command to Edit control
    PCTSTR cmd = g_Commands[id];
    SetDlgItemText(hDlg, IDC_EDIT1, cmd);
}


void OnSendButton(HWND hDlg)
{
    TCHAR buf[256];

    // Get Edit control text
    UINT count = GetDlgItemText(hDlg, IDC_EDIT1, buf, sizeof(buf)/sizeof(buf[0]));

    if (count > 0)
    {
#if UNICODE
        // Convert UTF-16 to ASCII
        for (UINT n = 0; n < count; n++)
            ((PBYTE)buf)[n] = (BYTE)buf[n];
#endif
        // Write command string to RS322
        WriteRS323(buf, count);
    }
}


INT_PTR CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
        case WM_COMMAND:
        {
            INT id = LOWORD(wParam);

            if (id == IDCANCEL || id == IDOK)
            {
                SendMessage(hDlg, WM_CLOSE, 0, 0);
                return TRUE;
            }

            if (id == IDC_SEND)
            {
                OnSendButton(hDlg);
            }

            if (id >= IDC_BUTTON1 && id <= IDC_BUTTON32)
            {
                OnCommandButton(hDlg, id-IDC_BUTTON1);
            }
        }
        break;

        case WM_CLOSE:
        {
            if(MessageBox(hDlg, _T("Program beenden?"), _T("Exit"),
                        MB_ICONQUESTION | MB_YESNO) == IDYES)
            {
                DestroyWindow(hDlg);
            }
        }
        return TRUE;

        case WM_DESTROY:
        {
            PostQuitMessage(0);
        }
        return TRUE;
    }

    return FALSE;
}


INT WINAPI _tWinMain(HINSTANCE hInst, HINSTANCE h0, LPTSTR lpCmdLine, INT nCmdShow)
{
    MSG  msg;
    BOOL ret;

    InitCommonControls();
    HWND hDlg = CreateDialogParam(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), 0, DialogProc, 0);
    ShowWindow(hDlg, nCmdShow);

    while ((ret = GetMessage(&msg, 0, 0, 0)) != 0)
    {
        if (ret == -1) return -1;

        if (!IsDialogMessage(hDlg, &msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }

    return 0;
}
